Index: tmp/org.txm.rcp/src/main/java/org/txm/rcp/swt/widget/parameters/ParametersDialog.java
===================================================================
--- tmp/org.txm.rcp/src/main/java/org/txm/rcp/swt/widget/parameters/ParametersDialog.java	(revision 3021)
+++ tmp/org.txm.rcp/src/main/java/org/txm/rcp/swt/widget/parameters/ParametersDialog.java	(revision 3022)
@@ -17,13 +17,8 @@
 import org.eclipse.jface.dialogs.Dialog;
 import org.eclipse.jface.dialogs.IDialogConstants;
 import org.eclipse.swt.SWT;
-import org.eclipse.swt.custom.ScrolledComposite;
-import org.eclipse.swt.events.ControlAdapter;
-import org.eclipse.swt.events.ControlEvent;
 import org.eclipse.swt.events.SelectionAdapter;
 import org.eclipse.swt.events.SelectionEvent;
-import org.eclipse.swt.graphics.Point;
-import org.eclipse.swt.graphics.Rectangle;
 import org.eclipse.swt.layout.GridData;
 import org.eclipse.swt.layout.GridLayout;
 import org.eclipse.swt.widgets.Button;
@@ -44,39 +39,39 @@
 
 @SuppressWarnings("rawtypes")
 public class ParametersDialog extends Dialog {
-
+	
 	public int MAX_PARAMETERS_PER_LINE = 10;
-
+	
 	Object bean;
-
+	
 	String script;
-
+	
 	String title;
-
+	
 	List<NamedOptionDef> parameters;
-
+	
 	List<String> fieldNames = new ArrayList<>(); // store all the declared parameters names
-
+	
 	LinkedHashMap<String, ParameterField> widgets = new LinkedHashMap<>();
-
+	
 	protected boolean error = false;
-
+	
 	protected Map args; // store values given by another Macro, if contains all the needed values, no dialog is shown
-
+	
 	protected int numberOfParameters; // number of parameters to show in the dialog box (not set by 'args'), if 0 parameters no dialog is shown
-
+	
 	protected boolean mustShowDialog; // show dialog if args.size == 0 OR if there is at least one mandatory field to set
-
+	
 	HashMap<String, Object> values = new HashMap<>(); // store the values of the parameters (may not contains all the values needed
-
+	
 	Properties defaultValues; // default values set by the .properties file
-
+	
 	Properties defaultScriptValues = new Properties(); // default values set by the Groovy script @Field@def annotation attribute
-
+	
 	File propFile;
 	// private int titleWidth;
 	// private Composite parent;
-
+	
 	/**
 	 * 
 	 * @param parentShell
@@ -93,7 +88,7 @@
 		this.bean = bean;
 		this.args = args;
 		setShellStyle(getShellStyle() | SWT.RESIZE);
-
+		
 		// count the number of fields to show. If "0" then don't show the dialog, see the "open()" function
 		// and select only the NamedOptionDef annotations
 		numberOfParameters = 0; // number of parameters not set by args
@@ -106,25 +101,25 @@
 				if (args.containsKey(option.name())) {
 					continue; // don't show the field
 				}
-
+				
 				// count number of mandatory fields set AND add exception for "Separator" widget types
 				if (option.required() || "Separator".equals(option.widget())) numberOfMandatoryFields++;
 				numberOfParameters++;
 			}
 		}
-
+		
 		mustShowDialog = numberOfMandatoryFields > 0 || (args.size() == 0 && numberOfParameters > 0);
-
+		
 		// initialize the properties file default values store
 		defaultValues = new Properties();
 		String scriptRootDir = Toolbox.getTxmHomePath() + "/scripts/groovy/user"; //$NON-NLS-1$
-
+		
 		propFile = new File(scriptRootDir, this.script.replace(".", "/") + ".properties");
-
+		
 		loadDefaultValuesFromPropFile();
 	}
-
-
+	
+	
 	private void loadDefaultValuesFromPropFile() {
 		if (propFile.exists()) {
 			try {
@@ -136,7 +131,7 @@
 				Log.printStackTrace(e);
 			}
 		}
-
+		
 		// initialize the script default values
 		for (NamedOptionDef option : this.parameters) {
 			String widgetName = option.widget();
@@ -201,7 +196,7 @@
 			}
 		}
 	}
-
+	
 	/*
 	 * (non-Javadoc)
 	 * @see org.eclipse.jface.window.Window#configureShell(org.eclipse.swt.widgets.Shell)
@@ -214,41 +209,41 @@
 		title = TXMUIMessages.bind(TXMUIMessages.p0ParametersInput, script.substring(script.lastIndexOf(".") + 1, idx2));
 		newShell.setText(title);
 		newShell.setMinimumSize(250, 450);
-
-//		newShell.addControlListener(new ControlAdapter() {
-//			public void controlResized(ControlEvent e) {
-//				Rectangle area = newShell.getClientArea();
-//				Point preferredSize = table.computeSize(SWT.DEFAULT, SWT.DEFAULT);
-//				int width = area.width - 2*table.getBorderWidth();
-//				if (preferredSize.y > area.height + table.getHeaderHeight()) {
-//					// Subtract the scrollbar width from the total column width
-//					// if a vertical scrollbar will be required
-//					Point vBarSize = table.getVerticalBar().getSize();
-//					width -= vBarSize.x;
-//				}
-//				Point oldSize = table.getSize();
-//				if (oldSize.x > area.width) {
-//					// table is getting smaller so make the columns // smaller first and then resize the table to
-//					// match the client area width
-//					column1.setWidth(width/3);
-//					column2.setWidth(width - column1.getWidth());
-//					table.setSize(area.width, area.height);
-//				} else {
-//					// table is getting bigger so make the table // bigger first and then make the columns wider
-//					// to match the client area width
-//					table.setSize(area.width, area.height);
-//					column1.setWidth(width/3);
-//					column2.setWidth(width - column1.getWidth());
-//				}
-//			}
-//		});
+		
+		// newShell.addControlListener(new ControlAdapter() {
+		// public void controlResized(ControlEvent e) {
+		// Rectangle area = newShell.getClientArea();
+		// Point preferredSize = table.computeSize(SWT.DEFAULT, SWT.DEFAULT);
+		// int width = area.width - 2*table.getBorderWidth();
+		// if (preferredSize.y > area.height + table.getHeaderHeight()) {
+		// // Subtract the scrollbar width from the total column width
+		// // if a vertical scrollbar will be required
+		// Point vBarSize = table.getVerticalBar().getSize();
+		// width -= vBarSize.x;
+		// }
+		// Point oldSize = table.getSize();
+		// if (oldSize.x > area.width) {
+		// // table is getting smaller so make the columns // smaller first and then resize the table to
+		// // match the client area width
+		// column1.setWidth(width/3);
+		// column2.setWidth(width - column1.getWidth());
+		// table.setSize(area.width, area.height);
+		// } else {
+		// // table is getting bigger so make the table // bigger first and then make the columns wider
+		// // to match the client area width
+		// table.setSize(area.width, area.height);
+		// column1.setWidth(width/3);
+		// column2.setWidth(width - column1.getWidth());
+		// }
+		// }
+		// });
 	}
 	
 	@Override
 	protected boolean isResizable() {
-	    return true;
+		return true;
 	}
-
+	
 	@Override
 	protected void createButtonsForButtonBar(Composite parent) {
 		// create the reset button (hack of the Back button)
@@ -270,12 +265,12 @@
 		// }
 		// }
 		// });
-
+		
 		Button button = createButton(parent, IDialogConstants.BACK_ID, "Reset values", false);
 		button.removeListener(SWT.Selection, button.getListeners(SWT.Selection)[0]);
-
+		
 		button.addSelectionListener(new SelectionAdapter() {
-
+			
 			@Override
 			public void widgetSelected(SelectionEvent e) {
 				// System.out.println("Reseting fields to default values");
@@ -285,24 +280,24 @@
 			}
 		});
 		if (numberOfParameters == 0) button.setEnabled(false);
-
+		
 		super.createButtonsForButtonBar(parent);
 		this.getButton(IDialogConstants.OK_ID).setText(TXMUIMessages.run);
 	}
-
+	
 	@Override
 	protected Control createButtonBar(Composite parent) {
 		Control c = super.createButtonBar(parent);
-
+		
 		// int barWidth = c.getSize().x;
 		// if (barWidth > titleWidth) {
 		// GridData cdata = (GridData)(this.parent.getLayoutData());
 		// cdata.widthHint = barWidth;
 		// }
-
+		
 		return c;
 	}
-
+	
 	/*
 	 * (non-Javadoc)
 	 * @see org.eclipse.jface.dialogs.Dialog#createDialogArea(org.eclipse.swt.widgets.Composite)
@@ -311,30 +306,30 @@
 	protected Control createDialogArea(Composite composite) {
 		// this.parent = composite;
 		super.createDialogArea(composite);
-
+		
 		composite.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true));
 		GridLayout layout = new GridLayout(1, true);
 		composite.setLayout(layout);
-
-//		ScrolledComposite scrolledComposite = new ScrolledComposite(composite, SWT.BORDER| SWT.H_SCROLL | SWT.V_SCROLL);
-//		scrolledComposite.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true));
-//		scrolledComposite.setLayout(new GridLayout(1, true));
-
+		
+		// ScrolledComposite scrolledComposite = new ScrolledComposite(composite, SWT.BORDER| SWT.H_SCROLL | SWT.V_SCROLL);
+		// scrolledComposite.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true));
+		// scrolledComposite.setLayout(new GridLayout(1, true));
+		
 		GLComposite columns = new GLComposite(composite, SWT.NONE, "columns");
 		columns.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true));
 		columns.getLayout().numColumns = 1;
-
-//		scrolledComposite.setContent(columns);
-//		scrolledComposite.addListener( SWT.Resize, event -> {
-//			  int width = scrolledComposite.getClientArea().width;
-//			  scrolledComposite.setMinSize( composite.computeSize( width, SWT.DEFAULT ) );
-//			} );
-
-
+		
+		// scrolledComposite.setContent(columns);
+		// scrolledComposite.addListener( SWT.Resize, event -> {
+		// int width = scrolledComposite.getClientArea().width;
+		// scrolledComposite.setMinSize( composite.computeSize( width, SWT.DEFAULT ) );
+		// } );
+		
+		
 		if (numberOfParameters > MAX_PARAMETERS_PER_LINE) {
 			columns.getLayout().numColumns = 1 + (numberOfParameters / MAX_PARAMETERS_PER_LINE);
 		}
-
+		
 		GLComposite column = new GLComposite(columns, SWT.NONE, "column");
 		GridData gdata = new GridData(SWT.FILL, SWT.FILL, true, true);
 		gdata.minimumWidth = 200;
@@ -352,7 +347,7 @@
 				column.setLayoutData(gdata);
 				column.getLayout().makeColumnsEqualWidth = false;
 			}
-
+			
 			// each widget is initialized with de default value set in @Field@def attribute
 			String widgetName = option.widget();
 			ParameterField widget = null;
@@ -407,10 +402,10 @@
 			else {
 				System.out.println(TXMUIMessages.unknowedWidgetNameColon + widgetName + TXMUIMessages.FileTreeContentProvider_4);
 			}
-
+			
 			if (widget != null) {
 				widgets.put(option.name(), widget);
-
+				
 				// set default value in the fields, not enough if args contains the value
 				String value = defaultValues.getProperty(option.name());
 				if (value != null) { // set the default value using the properties stored
@@ -419,10 +414,10 @@
 			}
 		}
 		new Label(composite, SWT.NONE).setText(TXMUIMessages.mandatoryFields);
-
+		
 		return composite;
 	}
-
+	
 	/*
 	 * (non-Javadoc)
 	 * @see org.eclipse.jface.dialogs.Dialog#okPressed()
@@ -430,12 +425,12 @@
 	@Override
 	protected void okPressed() {
 		error = false;
-
+		
 		// get widget values
 		for (String field : widgets.keySet()) {
 			ParameterField w = widgets.get(field);
 			Object value = w.getWidgetValue();
-
+			
 			// is widget set if mandatory EXCEPT "Separator" widgets
 			if (w.isWidgetMandatory() && value == null && !("Separator".equals(w.getWidgetType()))) {
 				System.out.println(TXMUIMessages.errorColonMissingValueColon + field);
@@ -446,18 +441,18 @@
 				// System.out.println(""+field+"\t"+values.get(field));
 			} // else value is not filled
 		}
-
+		
 		// initialize variables
 		if (!error) {
 			initializeMacroVariables();
 			saveParameters();
-
+			
 			if (!error) {
 				super.okPressed();
 			}
 		}
 	}
-
+	
 	private void saveParameters() {
 		if (!error) {
 			try {
@@ -470,15 +465,15 @@
 			}
 		}
 	}
-
-
+	
+	
 	/**
 	 * can use the args map to initialize variable not set with the dialog box
 	 */
 	private void initializeMacroVariables() {
 		// System.out.println("Initialize macro variables of "+fieldNames);
 		if (bean == null) return;
-
+		
 		Class c = bean.getClass();
 		for (String name : fieldNames) {
 			Object value = values.get(name);
@@ -497,7 +492,7 @@
 					defaultValues.setProperty(name, value.toString());
 				}
 			}
-
+			
 			try {
 				// System.out.println("setting "+name+ " with "+values.get(name));
 				Field field = c.getDeclaredField(name);
@@ -509,21 +504,21 @@
 				Log.printStackTrace(e);
 				error = true;
 			}
-
+			
 		}
 	}
-
-
+	
+	
 	protected boolean isError() {
 		return error;
 	}
-
+	
 	public HashMap<String, Object> getValues() {
 		return values;
 	}
-
+	
 	static boolean errorOpen, retOpen;
-
+	
 	/**
 	 * Conveniance method to initialize the parameters dialog.
 	 * Can detect the "args" Groovy binding and use it to set variables
@@ -535,22 +530,22 @@
 	public static boolean open(final Object bean) {
 		errorOpen = true;
 		retOpen = false;
-
+		
 		// if (!(bean instanceof groovy.lang.Script)) {
 		// System.out.println(Messages.ParametersDialog_15);
 		// return false;
 		// }
-
+		
 		Object oArgs = null;
 		if (bean instanceof groovy.lang.Script) {
 			groovy.lang.Script script = (groovy.lang.Script) bean;
-
+			
 			// if the "args" variable exists then use its values. Can be used to set a default value by another Macro
 			if (script.getBinding().hasVariable("args")) {
 				oArgs = script.getBinding().getVariable("args"); //$NON-NLS-1$
 			}
 		}
-
+		
 		final Map args;
 		if (oArgs == null || !(oArgs instanceof Map)) {
 			args = new HashMap<String, Object>();
@@ -558,24 +553,24 @@
 		else {
 			args = (Map) oArgs;
 		}
-
+		
 		if (bean instanceof groovy.lang.Script) { // create the args binding if not already existing
 			groovy.lang.Script script = (groovy.lang.Script) bean;
 			if (!script.getBinding().hasVariable("args")) {
 				script.getBinding().setVariable("args", args);
 			}
 		}
-
+		
 		Display.getDefault().syncExec(new Runnable() {
-
+			
 			@Override
 			public void run() {
 				boolean okNames = true;
 				CmdLineParser parser = new CmdLineParser(bean);
-
+				
 				Display display = Display.getCurrent();
 				Shell shell = display.getActiveShell();
-
+				
 				// check names
 				Class c = bean.getClass();
 				for (OptionHandler opt : parser.getOptions()) {
@@ -604,7 +599,7 @@
 						retOpen = true;
 						errorOpen = false;
 					}
-
+					
 					if (bean instanceof groovy.lang.Script) { // reset the timer binding if already existing
 						groovy.lang.Script script = (groovy.lang.Script) bean;
 						if (script.getBinding().hasVariable("timer")) {
@@ -617,15 +612,15 @@
 		});
 		return retOpen && !errorOpen;
 	}
-
+	
 	public boolean getMustShowDialog() {
 		return mustShowDialog;
 	}
-
+	
 	protected int getNumberOfFields() {
 		return numberOfParameters;
 	}
-
+	
 	// TODO: uncomment this to enable "args" detection
 	// public int open() {
 	// System.out.println("Number of parameters: "+numberOfParameters);
Index: tmp/org.txm.rcp/src/main/java/org/txm/rcp/swt/widget/parameters/ParametersManager.java
===================================================================
--- tmp/org.txm.rcp/src/main/java/org/txm/rcp/swt/widget/parameters/ParametersManager.java	(revision 0)
+++ tmp/org.txm.rcp/src/main/java/org/txm/rcp/swt/widget/parameters/ParametersManager.java	(revision 3022)
@@ -0,0 +1,435 @@
+package org.txm.rcp.swt.widget.parameters;
+
+import java.io.File;
+import java.io.IOException;
+import java.io.PrintWriter;
+import java.lang.reflect.Field;
+import java.text.ParseException;
+import java.util.ArrayList;
+import java.util.Collection;
+import java.util.Date;
+import java.util.LinkedHashMap;
+import java.util.List;
+import java.util.Map;
+import java.util.Properties;
+
+import org.kohsuke.args4j.CmdLineParser;
+import org.kohsuke.args4j.NamedOptionDef;
+import org.txm.rcp.messages.TXMUIMessages;
+import org.txm.searchengine.cqp.corpus.query.CQLQuery;
+import org.txm.utils.io.IOUtils;
+import org.txm.utils.logger.Log;
+
+/**
+ * Manages parameter and default parameters.
+ * 
+ * Store parameters history
+ * 
+ * export to properties or LinkedHashMap.
+ * 
+ * @author mdecorde
+ *
+ */
+public class ParametersManager {
+	
+	/**
+	 * parameters informations to manage the values
+	 */
+	LinkedHashMap<String, NamedOptionDef> parameters;
+	
+	/**
+	 * values set by default
+	 */
+	LinkedHashMap<String, Object> defaultValues = new LinkedHashMap<>();
+	
+	/**
+	 * values set by the user
+	 */
+	LinkedHashMap<String, Object> chosenValues = new LinkedHashMap<>();
+	
+	ArrayList<LinkedHashMap<String, Object>> history = new ArrayList<>();
+	
+	int MAX_HISTORY = 10;
+	
+	/**
+	 * Default history size = 10
+	 */
+	public ParametersManager() {
+		
+	}
+	
+	/**
+	 * 
+	 * @param history_size 0 or + ; 0 deactivate history
+	 */
+	public ParametersManager(int history_size) {
+		if (history_size >= 0) {
+			MAX_HISTORY = history_size;
+		}
+	}
+	
+	public boolean setParametersOptions(List<NamedOptionDef> parameters) {
+		this.parameters = new LinkedHashMap<>();
+		for (NamedOptionDef def : parameters) {
+			this.parameters.put(def.name(), def);
+		}
+		
+		return validateParametersDefinition().size() == 0;
+	}
+	
+	public List<String> validateParametersDefinition() {
+		if (parameters == null) return new ArrayList<>();
+		
+		ArrayList<String> errors = new ArrayList<>();
+		for (NamedOptionDef p : parameters.values()) {
+			if (!CmdLineParser.widgets.contains(p.widget())) {
+				errors.add(p.name());
+			}
+		}
+		return errors;
+	}
+	
+	/**
+	 * 
+	 * @return true if ALL mandatory parameters are set
+	 */
+	public boolean validate() {
+		for (NamedOptionDef def : parameters.values()) {
+			String key = def.name();
+			if (!defaultValues.containsKey(key) && !chosenValues.containsKey(key)) {
+				return false;
+			}
+		}
+		return true;
+	}
+	
+	/**
+	 * 
+	 * @return true if chosen values are restored
+	 */
+	public boolean historyBack() {
+		if (MAX_HISTORY <= 0) { // no history
+			return false;
+		}
+		
+		if (history.size() > 0) {
+			
+			history.remove(history.size() - 1); // remove current
+			
+			chosenValues = history.get(history.size() - 1);
+			System.out.println("restore: " + chosenValues);
+			return true;
+		}
+		else {
+			return false;
+		}
+	}
+	
+	// /**
+	// *
+	// * @return true if chosen values are forwarded
+	// */
+	// public boolean historyForward() {
+	// if (MAX_HISTORY <= 0) { // no history
+	// return false;
+	// }
+	// if (historyPointer < MAX_HISTORY) {
+	// historyPointer++;
+	// chosenValues = history.get(historyPointer);
+	// return true;
+	// }
+	// else {
+	// return false;
+	// }
+	// }
+	
+	/**
+	 * update history if MAX_HISTORY > 0
+	 */
+	protected void historyUpdate() {
+		if (MAX_HISTORY <= 0) { // no history
+			return;
+		}
+		LinkedHashMap<String, Object> clone = (LinkedHashMap<String, Object>) chosenValues.clone();
+		// for (String k : clone) { clone.put(k, clone.get(k).clone())
+		history.add(clone);
+		
+		if (history.size() > MAX_HISTORY) {
+			history.remove(0);
+		}
+	}
+	
+	
+	public ParametersManager(LinkedHashMap<String, Object> initialValues) {
+		updateChosenValues(initialValues);
+	}
+	
+	public ParametersManager(LinkedHashMap<String, Object> initialValues, LinkedHashMap<String, Object> defaultValues) {
+		updateChosenValues(initialValues);
+		updateDefaultValues(defaultValues);
+	}
+	
+	
+	public void clearChosenValue() {
+		chosenValues.clear();
+		
+		historyUpdate();
+	}
+	
+	public void updateChosenValue(String key, Object value) {
+		chosenValues.put(key, value);
+		
+		historyUpdate();
+	}
+	
+	public void updateChosenValues(LinkedHashMap<String, Object> newChosenValues) {
+		for (String key : newChosenValues.keySet()) {
+			chosenValues.put(key, newChosenValues.get(key));
+		}
+		
+		historyUpdate();
+	}
+	
+	public void removeChosenValue(String key) {
+		chosenValues.remove(key);
+		
+		historyUpdate();
+	}
+	
+	public void removeChosenValues(Collection<String> keys) {
+		for (String key : keys) {
+			chosenValues.remove(key);
+		}
+		
+		historyUpdate();
+	}
+	
+	public void clearDefaultValues(LinkedHashMap<String, Object> newDefaultValues) {
+		defaultValues.clear();
+	}
+	
+	public void updateDefaultValues(Map<String, Object> newDefaultValues) {
+		for (String key : newDefaultValues.keySet()) {
+			defaultValues.put(key, newDefaultValues.get(key));
+		}
+	}
+	
+	public void updateDefaultValue(String key, Object value) {
+		defaultValues.put(key, value);
+	}
+	
+	public void removeDefaultValue(String key) {
+		defaultValues.remove(key);
+	}
+	
+	public void removeDefaultValue(Collection<String> keys) {
+		for (String key : keys) {
+			defaultValues.remove(key);
+		}
+	}
+	
+	/**
+	 * compile default and chosen values
+	 * 
+	 * @return
+	 */
+	public LinkedHashMap<String, Object> getFinalValues() {
+		LinkedHashMap<String, Object> finalValues = new LinkedHashMap<>(defaultValues);
+		for (String key : chosenValues.keySet()) {
+			finalValues.put(key, chosenValues.get(key));
+		}
+		return finalValues;
+	}
+	
+	/**
+	 * compile and export values to a Properties object
+	 * 
+	 * @return
+	 */
+	public Properties finalToProperties() {
+		Properties props = new Properties();
+		LinkedHashMap<String, Object> values = getFinalValues();
+		for (String k : values.keySet()) {
+			if (values.get(k).toString() != null) {
+				props.setProperty(k, values.get(k).toString());
+			}
+		}
+		return props;
+	}
+	
+	/**
+	 * read parameters from a Properties object.
+	 * Values are casted to specific object if the parameters informations are set
+	 * 
+	 * @return a hashmap of values (Object)
+	 */
+	public LinkedHashMap<String, Object> propertiesToValues(Properties props) {
+		LinkedHashMap<String, Object> newChosenValues = new LinkedHashMap<>();
+		for (Object okey : props.keySet()) {
+			String key = okey.toString();
+			String stringValue = props.getProperty(key);
+			
+			Object value = stringToValue(stringValue, key);
+			
+			newChosenValues.put(key, value);
+		}
+		
+		return newChosenValues;
+	}
+	
+	/**
+	 * read parameters from a HashMap<String, String> object.
+	 * Values are casted to specific object if the parameters informations are set
+	 * 
+	 * @return
+	 */
+	public LinkedHashMap<String, Object> hashToValues(Map<String, String> map) {
+		LinkedHashMap<String, Object> newChosenValues = new LinkedHashMap<>();
+		for (String key : map.keySet()) {
+			String stringValue = map.get(key);
+			
+			Object value = stringToValue(stringValue, key);
+			
+			newChosenValues.put(key, value);
+		}
+		
+		return newChosenValues;
+	}
+	
+	private Object stringToValue(String stringValue, String key) {
+		if (stringValue == null) return null;
+		
+		String widgetName = getParameterType(key);
+		
+		Object value = null;
+		if ("File".equals(widgetName) || "FileOpen".equals(widgetName)) { //$NON-NLS-1$
+			value = new File(stringValue);
+		}
+		else if ("CreateFile".equals(widgetName) || "FileSave".equals(widgetName)) { //$NON-NLS-1$
+			value = new File(stringValue);
+		}
+		else if ("Folder".equals(widgetName)) { //$NON-NLS-1$
+			value = new File(stringValue);
+		}
+		else if ("Query".equals(widgetName)) { //$NON-NLS-1$
+			value = new CQLQuery(stringValue);
+		}
+		else if ("Date".equals(widgetName)) { //$NON-NLS-1$
+			try {
+				value = DateField.formater.parse(stringValue);
+			}
+			catch (ParseException e) {
+				Log.severe("Wrong default date format: " + stringValue + ". Waiting for: " + DateField.STRINGFORMAT + ". Error = " + e + ".");
+				value = new Date();
+			}
+		}
+		else if ("Time".equals(widgetName)) { //$NON-NLS-1$
+			value = Integer.parseInt(stringValue);
+		}
+		else if ("String".equals(widgetName)) { //$NON-NLS-1$
+			value = stringValue;
+		}
+		else if ("Separator".equals(widgetName)) { //$NON-NLS-1$
+			value = stringValue;
+		}
+		else if ("Password".equals(widgetName)) { //$NON-NLS-1$
+			value = stringValue;
+		}
+		else if ("StringArray".equals(widgetName)) { //$NON-NLS-1$
+			value = stringValue;
+		}
+		else if ("StringArrayMultiple".equals(widgetName)) { //$NON-NLS-1$
+			value = stringValue;
+		}
+		else if ("StructuralUnits".equals(widgetName)) { //$NON-NLS-1$
+			value = stringValue;
+		}
+		else if ("Text".equals(widgetName)) { //$NON-NLS-1$
+			value = stringValue;
+		}
+		else if ("Integer".equals(widgetName)) { //$NON-NLS-1$
+			value = Integer.parseInt(stringValue);
+		}
+		else if ("Float".equals(widgetName)) { //$NON-NLS-1$
+			value = Float.parseFloat(stringValue);
+		}
+		else if ("Boolean".equals(widgetName)) { //$NON-NLS-1$
+			value = Boolean.parseBoolean(stringValue);
+		}
+		else {
+			value = stringValue;
+		}
+		
+		return value;
+	}
+	
+	private String getParameterType(String key) {
+		if (key == null || parameters == null || !parameters.containsKey(key)) {
+			return "String";
+		}
+		
+		return parameters.get(key).widget();
+	}
+	
+	/**
+	 * compile and export values to a Properties object
+	 * 
+	 * @return true if bean fields have been updated
+	 */
+	public boolean finalToBean(Object bean) {
+		if (bean == null) return false;
+		boolean ok = true;
+		LinkedHashMap<String, Object> values = getFinalValues();
+		
+		Class<?> c = bean.getClass();
+		for (String name : values.keySet()) {
+			
+			try {
+				// System.out.println("setting "+name+ " with "+values.get(name));
+				Field field = c.getDeclaredField(name);
+				field.setAccessible(true); // enable
+				field.set(bean, values.get(name));
+			}
+			catch (Exception e) {
+				System.out.println(TXMUIMessages.errorInAtOptionNameDeclarationColon + e.getMessage());
+				Log.printStackTrace(e);
+				ok = false;
+			}
+		}
+		return ok;
+	}
+	
+	/**
+	 * compile and export values to a Properties object
+	 * 
+	 * @return
+	 * @throws IOException
+	 */
+	public void finalToFile(File propFile) throws IOException {
+		Properties props = finalToProperties();
+		PrintWriter writer = IOUtils.getWriter(propFile);
+		props.store(writer, "TXM parameters");
+		writer.close();
+		return;
+	}
+	
+	public static void main(String[] args) {
+		AtestClass atc = new AtestClass();
+		ParametersManager pm = new ParametersManager();
+		pm.updateChosenValue("file", new File("testfile"));
+		pm.updateChosenValue("dir", new File("testdir"));
+		pm.updateChosenValue("ii", 1);
+		pm.historyBack();
+		pm.historyBack();
+		pm.finalToBean(atc);
+		System.out.println("atc=" + atc);
+	}
+	
+	public LinkedHashMap<String, Object> getDefaultValues() {
+		return defaultValues;
+	}
+	
+	public LinkedHashMap<String, NamedOptionDef> getParameters() {
+		return parameters;
+	}
+}

Index: tmp/org.txm.rcp/src/main/java/org/txm/rcp/messages/TXMUIMessages.java
===================================================================
--- tmp/org.txm.rcp/src/main/java/org/txm/rcp/messages/TXMUIMessages.java	(revision 3021)
+++ tmp/org.txm.rcp/src/main/java/org/txm/rcp/messages/TXMUIMessages.java	(revision 3022)
@@ -602,7 +602,7 @@
 	
 	public static String loadingTheP0BinaryCorpusAsATXM079Corpus;
 	
-	public static String loadingTheP0BinaryCorpusAsATXM080Corpus;
+	public static String theP0BinaryCorpusVersionIsP1;
 	
 	public static String loadingViews;
 	
Index: tmp/org.txm.rcp/src/main/java/org/txm/rcp/views/cmdparameters/TXMResultPreferencesView.java
===================================================================
--- tmp/org.txm.rcp/src/main/java/org/txm/rcp/views/cmdparameters/TXMResultPreferencesView.java	(revision 3021)
+++ tmp/org.txm.rcp/src/main/java/org/txm/rcp/views/cmdparameters/TXMResultPreferencesView.java	(revision 3022)
@@ -28,9 +28,7 @@
 package org.txm.rcp.views.cmdparameters;
 
 import java.lang.reflect.Field;
-import java.util.Arrays;
 import java.util.HashSet;
-import java.util.List;
 
 import org.eclipse.core.internal.resources.ProjectPreferences;
 import org.eclipse.jface.dialogs.InputDialog;
@@ -54,14 +52,13 @@
 import org.eclipse.ui.PlatformUI;
 import org.eclipse.ui.part.ViewPart;
 import org.osgi.service.prefs.BackingStoreException;
-import org.osgi.service.prefs.Preferences;
 import org.txm.core.results.Parameter;
 import org.txm.core.results.TXMResult;
 import org.txm.rcp.views.corpora.CorporaView;
 import org.txm.utils.logger.Log;
 
 /**
- * Alternative display of the TXMEditor form fields
+ * Provide an access to the TXMResult RCP preferences values
  * 
  * @author mdecorde.
  */
@@ -72,7 +69,7 @@
 	
 	private Text refs;
 	
-	private ParametersComposite parametersComposite;
+	private TXMResultParametersComposite parametersComposite;
 	
 	static HashSet<String> txmResultEntries = new HashSet<>();
 	static {
@@ -163,7 +160,7 @@
 		new Label(parent, SWT.NONE).setText("properties");
 		
 		refs = new Text(parent, SWT.BORDER);
-		refs.setText(ParametersComposite.DEFAULT_REFS);
+		refs.setText(TXMResultParametersComposite.DEFAULT_REFS);
 		refs.addKeyListener(new KeyListener() {
 			
 			@Override
@@ -243,7 +240,7 @@
 		
 		refresh.setLayoutData(GridDataFactory.fillDefaults().align(GridData.BEGINNING, GridData.BEGINNING).grab(false, false).create());
 		
-		parametersComposite = new ParametersComposite(parent, SWT.NONE);
+		parametersComposite = new TXMResultParametersComposite(parent, SWT.NONE);
 		parametersComposite.setLayoutData(GridDataFactory.fillDefaults().align(GridData.FILL, GridData.FILL).grab(true, true).span(8, 1).create());
 	}
 	
